import React, { useRef, useEffect, useState } from 'react';
import { Checkbox } from 'semantic-ui-react';

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }

  return target;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };
  return _extends.apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function useFirstMountState() {
    var isFirst = useRef(true);
    if (isFirst.current) {
        isFirst.current = false;
        return true;
    }
    return isFirst.current;
}

var useUpdateEffect = function (effect, deps) {
    var isFirstMount = useFirstMountState();
    useEffect(function () {
        if (!isFirstMount) {
            return effect();
        }
    }, deps);
};
var useUpdateEffect$1 = useUpdateEffect;

var styles = {"treeview":"treeview-nPhGL","checkbox":"checkbox-xJke6","list":"list-ud7nT"};

var _excluded = ["data", "name", "value", "onChange"],
    _excluded2 = ["id", "children"];
var index = (function (_ref) {
  var _ref$data = _ref.data,
      initialData = _ref$data === void 0 ? [] : _ref$data,
      name = _ref.name,
      _ref$value = _ref.value,
      initialValue = _ref$value === void 0 ? '' : _ref$value,
      onChange = _ref.onChange,
      props = _objectWithoutProperties(_ref, _excluded);

  var split = function split(value) {
    return value === '' ? [] : value.split(',');
  };

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      data = _useState2[0],
      setData = _useState2[1];

  var _useState3 = useState(initialValue),
      _useState4 = _slicedToArray(_useState3, 2),
      value = _useState4[0],
      setValue = _useState4[1];

  var _useState5 = useState(new Set(split(initialValue))),
      _useState6 = _slicedToArray(_useState5, 2),
      ids = _useState6[0],
      setIds = _useState6[1];

  var _useState7 = useState(new Map()),
      _useState8 = _slicedToArray(_useState7, 2),
      itemMap = _useState8[0],
      setItemRefs = _useState8[1];

  var hiddenInputRef = useRef();
  useEffect(function () {
    setValue(initialValue);
    setIds(new Set(split(initialValue)));
  }, [initialValue]);
  useEffect(function () {
    var data = processItems(initialData);
    setData(data);
  }, [initialData, ids]);
  useEffect(function () {
    var value = Array.from(ids).join(',');
    setValue(value);
  }, [ids]);
  useUpdateEffect$1(function () {
    var event = new Event('input', {
      bubbles: true
    });
    hiddenInputRef.current.dispatchEvent(event);
  }, [value]);

  function processItems() {
    var items = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var parent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    return items.map(function (_ref2) {
      var id = _ref2.id,
          children = _ref2.children,
          props = _objectWithoutProperties(_ref2, _excluded2);

      var item = _objectSpread2(_objectSpread2({}, props), {}, {
        id: id,
        parent: parent
      });

      if (ids.has(id)) {
        item.checked = true;
      }

      if (Array.isArray(children)) {
        item.children = processItems(children, item);
        setItemState(item);
      }

      itemMap.set(id, item);
      return item;
    });
  }

  function setItemState(item) {
    var siblings = item.children;
    var checkedCount = siblings.reduce(function (count, _ref3) {
      var checked = _ref3.checked;
      return count + (checked ? 1 : 0);
    }, 0);
    var hasIndeterminate = siblings.some(function (item) {
      return item.indeterminate;
    });
    item.checked = checkedCount === siblings.length;
    item.indeterminate = hasIndeterminate || 0 < checkedCount && checkedCount < siblings.length;
  }

  function setParentStates(_ref4) {
    var parent = _ref4.parent;
    if (parent === null) return;
    setItemState(parent);
    setParentStates(parent);
  }

  function setChildStates(_ref5) {
    var children = _ref5.children,
        checked = _ref5.checked,
        id = _ref5.id;

    if (!Array.isArray(children)) {
      if (checked) {
        ids.add(id);
      } else {
        ids["delete"](id);
      }

      return;
    }

    children.forEach(function (item) {
      item.checked = checked;
      item.indeterminate = false;
      setChildStates(item);
    });
  }

  function handleChange(event, _ref6) {
    var checked = _ref6.checked;
    var id = event.target.parentElement.dataset.id;
    var item = itemMap.get(id);
    item.checked = checked;
    item.indeterminate = false;
    setChildStates(item);
    setParentStates(item);
    setItemRefs(new Map(itemMap));
    setIds(new Set(ids));
    event.stopPropagation();
  }

  function handleHiddenInput(event) {
    if (onChange) {
      event._reactName = 'onChange';
      event.type = 'change';
      onChange(event, value);
    }
  }

  var ItemList = function ItemList(_ref7) {
    var items = _ref7.items;
    return React.createElement("ul", {
      className: styles.list
    }, items.map(function (item, index) {
      return React.createElement(Item, {
        key: index,
        item: item
      });
    }));
  };

  var Item = function Item(_ref8) {
    var item = _ref8.item;
    return React.createElement("li", {
      className: styles.item
    }, React.createElement("label", null, React.createElement(Checkbox, {
      className: styles.checkbox,
      checked: item.checked,
      indeterminate: item.indeterminate,
      "data-id": item.id,
      onChange: handleChange
    }), item.label), item.children && React.createElement(ItemList, {
      items: item.children
    }));
  };

  return React.createElement("div", _extends({}, props, {
    className: styles.treeview
  }), React.createElement(ItemList, {
    items: data
  }), React.createElement("input", {
    type: "hidden",
    name: name,
    value: value,
    ref: hiddenInputRef,
    onInput: handleHiddenInput
  }));
});

export { index as TreeView };
